[BACK]Return to rc CVS log [TXT][DIR] Up to [local] / src / etc

Annotation of src/etc/rc, Revision 1.409

1.409   ! halex       1: #      $OpenBSD: rc,v 1.408 2013/12/15 17:40:45 tedu Exp $
1.1       deraadt     2:
                      3: # System startup script run by init on autoboot
                      4: # or after single-user.
                      5: # Output and error are redirected to console by init,
                      6: # and the console is the controlling terminal.
                      7:
1.131     millert     8: # Subroutines (have to come first).
                      9:
                     10: # Strip comments (and leading/trailing whitespace if IFS is set)
                     11: # from a file and spew to stdout
                     12: stripcom() {
                     13:        local _file="$1"
                     14:        local _line
                     15:
                     16:        {
                     17:                while read _line ; do
                     18:                        _line=${_line%%#*}              # strip comments
                     19:                        test -z "$_line" && continue
                     20:                        echo $_line
                     21:                done
                     22:        } < $_file
                     23: }
                     24:
1.265     millert    25: # Update resource limits when sysctl changes
                     26: # Usage: update_limit -X loginconf_name
                     27: update_limit() {
                     28:        local _fl="$1"  # ulimit flag
                     29:        local _lc="$2"  # login.conf name
                     30:        local _new _suf
                     31:
                     32:        for _suf in "" -cur -max; do
                     33:                _new=`getcap -f /etc/login.conf -s ${_lc}${_suf} daemon 2>/dev/null`
                     34:                if [ X"$_new" != X"" ]; then
                     35:                        if [ X"$_new" = X"infinity" ]; then
                     36:                                _new=unlimited
                     37:                        fi
                     38:                        case "$_suf" in
                     39:                        -cur)
                     40:                                ulimit -S $_fl $_new
                     41:                                ;;
                     42:                        -max)
                     43:                                ulimit -H $_fl $_new
                     44:                                ;;
                     45:                        *)
                     46:                                ulimit $_fl $_new
                     47:                                return
                     48:                                ;;
                     49:                        esac
                     50:                fi
                     51:        done
                     52: }
                     53:
                     54: sysctl_conf() {
1.267     millert    55:        test -s /etc/sysctl.conf || return
                     56:
1.265     millert    57:        # delete comments and blank lines
                     58:        set -- `stripcom /etc/sysctl.conf`
                     59:        while [ $# -ge 1 ] ; do
                     60:                sysctl $1
                     61:                # update limits if needed
                     62:                case $1 in
                     63:                kern.maxproc=*)
                     64:                        update_limit -p maxproc
                     65:                        ;;
                     66:                kern.maxfiles=*)
                     67:                        update_limit -n openfiles
                     68:                        ;;
                     69:                esac
                     70:                shift
                     71:        done
                     72: }
                     73:
                     74: mixerctl_conf()
                     75: {
1.267     millert    76:        test -s /etc/mixerctl.conf || return
                     77:
1.265     millert    78:        # delete comments and blank lines
                     79:        set -- `stripcom /etc/mixerctl.conf`
                     80:        while [ $# -ge 1 ] ; do
                     81:                mixerctl -q $1 > /dev/null 2>&1
                     82:                shift
                     83:        done
                     84: }
                     85:
1.267     millert    86: wsconsctl_conf()
                     87: {
                     88:        local save_IFS="$IFS"
                     89:
                     90:        test -x /sbin/wsconsctl -a -s /etc/wsconsctl.conf || return
                     91:        # delete comments and blank lines
                     92:        IFS="
                     93: "
                     94:        set -- `stripcom /etc/wsconsctl.conf`
                     95:        IFS="$save_IFS"
                     96:        while [ $# -ge 1 ] ; do
1.356     deraadt    97:                eval wsconsctl $1
1.267     millert    98:                shift
                     99:        done
                    100: }
                    101:
1.312     djm       102: random_seed()
                    103: {
1.389     deraadt   104:        if [ -f /var/db/host.random ]; then
1.347     deraadt   105:                dd if=/var/db/host.random of=/dev/arandom bs=65536 count=1 \
1.312     djm       106:                    > /dev/null 2>&1
1.389     deraadt   107:                chmod 600 /var/db/host.random >/dev/null 2>&1
1.328     deraadt   108:
1.312     djm       109:                # reset seed file, so that if a shutdown-less reboot occurs,
                    110:                # the next seed is not a repeat
1.347     deraadt   111:                dd if=/dev/arandom of=/var/db/host.random bs=65536 count=1 \
1.312     djm       112:                    > /dev/null 2>&1
                    113:        fi
                    114: }
                    115:
1.318     djm       116: fill_baddynamic()
                    117: {
1.390     halex     118:        local _service=$1
1.318     djm       119:        local _sysctl="net.inet.${_service}.baddynamic"
1.390     halex     120:        stripcom /etc/services |
                    121:        {
                    122:                # Variables are local
                    123:                while IFS="     /" read _name _port _srv _junk; do
1.391     halex     124:                        [ "x${_srv}" = "x${_service}" ] || continue
1.390     halex     125:                        _ban="${_ban:+${_ban},}+${_port}"
                    126:                        # Flush before argv gets too long
                    127:                        if [ ${#_ban} -gt 1024 ]; then
                    128:                                sysctl -q ${_sysctl}=${_ban}
                    129:                                _ban=""
                    130:                        fi
                    131:                done
                    132:                [ "${_ban}" ] && sysctl -q ${_sysctl}=${_ban}
                    133:        }
1.318     djm       134: }
                    135:
1.353     robert    136: start_daemon()
                    137: {
1.354     robert    138:        local _n
1.353     robert    139:        for _n; do
                    140:                eval _do=\${${_n}_flags}
                    141:                if [ X"${_do}" != X"NO" ]; then
                    142:                        /etc/rc.d/${_n} start
                    143:                fi
                    144:        done
                    145: }
                    146:
1.373     deraadt   147: make_keys()
                    148: {
                    149:        if [ X"${named_flags}" != X"NO" ]; then
                    150:                if ! cmp -s /etc/rndc.key /var/named/etc/rndc.key ; then
                    151:                        echo -n "rndc-confgen: generating shared secret... "
                    152:                        if rndc-confgen -a -t /var/named >/dev/null 2>&1; then
                    153:                                chmod 0640 /var/named/etc/rndc.key \
                    154:                                    >/dev/null 2>&1
                    155:                                echo done.
                    156:                        else
                    157:                                echo failed.
                    158:                        fi
                    159:                fi
                    160:        fi
                    161:
                    162:        if [ ! -f /etc/isakmpd/private/local.key ]; then
                    163:                echo -n "openssl: generating isakmpd/iked RSA key... "
                    164:                if openssl genrsa -out /etc/isakmpd/private/local.key 2048 \
                    165:                    >/dev/null 2>&1; then
                    166:                        chmod 600 /etc/isakmpd/private/local.key
                    167:                        openssl rsa -out /etc/isakmpd/local.pub -in \
                    168:                            /etc/isakmpd/private/local.key -pubout \
                    169:                            >/dev/null 2>&1
                    170:                        echo done.
                    171:                else
                    172:                        echo failed.
                    173:                fi
                    174:        fi
                    175:
                    176:        if [ ! -f /etc/iked/private/local.key ]; then
                    177:                # Just copy the generated isakmpd key
                    178:                cp /etc/isakmpd/private/local.key /etc/iked/private/local.key
                    179:                chmod 600 /etc/iked/private/local.key
                    180:                cp /etc/isakmpd/local.pub /etc/iked/local.pub
                    181:        fi
                    182:
                    183:        ssh-keygen -A
                    184: }
                    185:
                    186: # create Unix sockets directories for X if needed and make sure they have
                    187: # correct permissions
                    188: setup_X_sockets()
                    189: {
                    190:        if [ -d /usr/X11R6/lib ]; then
                    191:                for d in /tmp/.X11-unix /tmp/.ICE-unix ; do
                    192:                        if [ -d $d ]; then
                    193:                                if [ `ls -ld $d | cut -d' ' -f4` \
                    194:                                    != root ]; then
                    195:                                        chown root $d
                    196:                                fi
                    197:                                if [ `ls -ld $d | cut -d' ' -f1` \
                    198:                                    != drwxrwxrwt ]; then
                    199:                                        chmod 1777 $d
                    200:                                fi
                    201:                        elif [ -e $d ]; then
                    202:                                echo "Error: $d exists and isn't a directory."
                    203:                        else
                    204:                                mkdir -m 1777 $d
                    205:                        fi
                    206:                done
                    207:        fi
                    208: }
                    209:
1.131     millert   210: # End subroutines
                    211:
1.1       deraadt   212: stty status '^T'
                    213:
                    214: # Set shell to ignore SIGINT (2), but not children;
                    215: # shell catches SIGQUIT (3) and returns to single user after fsck.
                    216: trap : 2
                    217: trap : 3       # shouldn't be needed
                    218:
                    219: HOME=/; export HOME
1.349     robert    220: INRC=1; export INRC
1.1       deraadt   221: PATH=/sbin:/bin:/usr/sbin:/usr/bin
                    222: export PATH
1.395     deraadt   223:
                    224: # must set the domainname before rc.conf, so YP startup choices can be made
                    225: if [ -f /etc/defaultdomain ]; then
                    226:        domainname `stripcom /etc/defaultdomain`
                    227: fi
1.108     deraadt   228:
1.343     robert    229: # pick up option configuration
                    230: . /etc/rc.conf
                    231:
1.266     millert   232: if [ X"$1" = X"shutdown" ]; then
1.347     deraadt   233:        dd if=/dev/arandom of=/var/db/host.random bs=65536 count=1 >/dev/null 2>&1
1.108     deraadt   234:        chmod 600 /var/db/host.random >/dev/null 2>&1
1.405     ajacouto  235:        _c=$?
1.380     ajacouto  236:        if [ ${_c} -eq 0 -a -n "${pkg_scripts}" ]; then
1.352     ajacouto  237:                echo -n 'stopping package daemons:'
1.380     ajacouto  238:                while [ -n "${pkg_scripts}" ]; do
                    239:                        _r=${pkg_scripts##* }
                    240:                        pkg_scripts=${pkg_scripts%%*( )${_r}}
1.352     ajacouto  241:                        [ -x /etc/rc.d/${_r} ] && /etc/rc.d/${_r} stop
                    242:                done
                    243:                echo '.'
                    244:        fi
                    245:        if [ ${_c} -eq 0 -a -f /etc/rc.shutdown ]; then
1.108     deraadt   246:                echo /etc/rc.shutdown in progress...
                    247:                . /etc/rc.shutdown
                    248:                echo /etc/rc.shutdown complete.
1.240     mcbride   249:
                    250:                # bring carp interfaces down gracefully
1.331     sthen     251:                ifconfig | while read a b; do
                    252:                        case $a in
                    253:                        carp+([0-9]):) ifconfig ${a%:} down ;;
1.329     sthen     254:                        esac
1.240     mcbride   255:                done
1.246     mcbride   256:
1.266     millert   257:                if [ X"${powerdown}" = X"YES" ]; then
1.246     mcbride   258:                        exit 2
                    259:                fi
                    260:
1.108     deraadt   261:        else
                    262:                echo single user: not running /etc/rc.shutdown
                    263:        fi
                    264:        exit 0
1.1       deraadt   265: fi
1.98      jakob     266:
1.172     miod      267: swapctl -A -t blk
1.170     deraadt   268:
1.17      deraadt   269: if [ -e /fastboot ]; then
1.1       deraadt   270:        echo "Fast boot: skipping disk checks."
1.266     millert   271: elif [ X"$1" = X"autoboot" ]; then
1.1       deraadt   272:        echo "Automatic boot in progress: starting file system checks."
1.31      millert   273:        fsck -p
1.1       deraadt   274:        case $? in
                    275:        0)
                    276:                ;;
                    277:        2)
                    278:                exit 1
                    279:                ;;
                    280:        4)
                    281:                echo "Rebooting..."
                    282:                reboot
                    283:                echo "Reboot failed; help!"
                    284:                exit 1
                    285:                ;;
                    286:        8)
                    287:                echo "Automatic file system check failed; help!"
                    288:                exit 1
                    289:                ;;
                    290:        12)
                    291:                echo "Boot interrupted."
                    292:                exit 1
                    293:                ;;
                    294:        130)
                    295:                # interrupt before catcher installed
                    296:                exit 1
                    297:                ;;
                    298:        *)
                    299:                echo "Unknown error; help!"
                    300:                exit 1
                    301:                ;;
                    302:        esac
                    303: fi
                    304:
                    305: trap "echo 'Boot interrupted.'; exit 1" 3
                    306:
                    307: umount -a >/dev/null 2>&1
1.303     grunk     308: mount -a -t nonfs,vnd
1.57      niklas    309: mount -uw /            # root on nfs requires this, others aren't hurt
1.1       deraadt   310: rm -f /fastboot                # XXX (root now writeable)
1.177     deraadt   311:
1.255     henning   312: # set flags on ttys.  (do early, in case they use tty for SLIP in netstart)
1.1       deraadt   313: echo 'setting tty flags'
                    314: ttyflags -a
1.77      angelos   315:
1.252     mcbride   316: if [ -f /sbin/kbd -a -f /etc/kbdtype ]; then
                    317:        kbd `cat /etc/kbdtype`
                    318: fi
                    319:
1.279     deraadt   320: wsconsctl_conf
                    321:
1.266     millert   322: if [ X"${pf}" != X"NO" ]; then
1.211     mcbride   323:        RULES="block all"
1.228     henning   324:        RULES="$RULES\npass on lo0"
1.195     dhartmei  325:        RULES="$RULES\npass in proto tcp from any to any port 22 keep state"
1.208     camield   326:        RULES="$RULES\npass out proto { tcp, udp } from any to any port 53 keep state"
1.215     camield   327:        RULES="$RULES\npass out inet proto icmp all icmp-type echoreq keep state"
1.257     grange    328:        if ifconfig lo0 inet6 >/dev/null 2>&1; then
1.258     itojun    329:                RULES="$RULES\npass out inet6 proto icmp6 all icmp6-type neighbrsol"
                    330:                RULES="$RULES\npass in inet6 proto icmp6 all icmp6-type neighbradv"
1.257     grange    331:                RULES="$RULES\npass out inet6 proto icmp6 all icmp6-type routersol"
                    332:                RULES="$RULES\npass in inet6 proto icmp6 all icmp6-type routeradv"
                    333:        fi
1.322     mcbride   334:        RULES="$RULES\npass proto carp keep state (no-sync)"
1.193     deraadt   335:        case `sysctl vfs.mounts.nfs 2>/dev/null` in
1.184     deraadt   336:        *[1-9]*)
                    337:                # don't kill NFS
1.324     henning   338:                RULES="set reassemble yes no-df\n$RULES"
1.306     deraadt   339:                RULES="$RULES\npass in proto { tcp, udp } from any port { 111, 2049 } to any"
                    340:                RULES="$RULES\npass out proto { tcp, udp } from any to any port { 111, 2049 }"
1.184     deraadt   341:                ;;
                    342:        esac
1.269     dhartmei  343:        echo $RULES | pfctl -f -
                    344:        pfctl -e
1.176     kjell     345: fi
1.318     djm       346:
                    347: # Fill net.inet.(tcp|udp).baddynamic lists from /etc/services
                    348: fill_baddynamic udp
                    349: fill_baddynamic tcp
1.176     kjell     350:
1.267     millert   351: sysctl_conf
1.260     jsg       352:
1.1       deraadt   353: # set hostname, turn on network
                    354: echo 'starting network'
1.289     henning   355: ifconfig -g carp carpdemote 128
1.264     deraadt   356: if [ -f /etc/resolv.conf.save ]; then
1.334     deraadt   357:        mv -f /etc/resolv.conf.save /etc/resolv.conf
1.264     deraadt   358:        touch /etc/resolv.conf
                    359: fi
1.1       deraadt   360: . /etc/netstart
1.348     deraadt   361: echo rekey > /dev/arandom      # any write triggers an RC4 rekey
1.176     kjell     362:
1.266     millert   363: if [ X"${pf}" != X"NO" ]; then
1.176     kjell     364:        if [ -f ${pf_rules} ]; then
1.198     dhartmei  365:                pfctl -f ${pf_rules}
1.309     mpf       366:        fi
                    367:        # bring up pfsync after the working ruleset has been loaded
1.367     deraadt   368:        if [ -f /etc/hostname.pfsync0 ]; then
                    369:                . /etc/netstart pfsync0
                    370:        fi
1.176     kjell     371: fi
1.1       deraadt   372:
1.278     otto      373: mount -s /usr >/dev/null 2>&1
                    374: mount -s /var >/dev/null 2>&1
1.180     deraadt   375:
1.389     deraadt   376: random_seed
1.29      deraadt   377:
1.55      deraadt   378: # clean up left-over files
1.376     deraadt   379: rm -f /etc/nologin /var/spool/lock/LCK.* /var/spool/uucp/STST/*
1.247     henning   380: (cd /var/run && { rm -rf -- *; install -c -m 664 -g utmp /dev/null utmp; })
1.196     beck      381: (cd /var/authpf && rm -rf -- *)
1.96      alex      382:
                    383: # save a copy of the boot messages
                    384: dmesg >/var/run/dmesg.boot
1.55      deraadt   385:
1.373     deraadt   386: make_keys
                    387:
1.379     deraadt   388: echo -n 'starting early daemons:'
1.387     deraadt   389: start_daemon syslogd ldattach pflogd named nsd ntpd isakmpd iked sasyncd
1.403     yasuoka   390: start_daemon ldapd npppd
1.353     robert    391: echo '.'
1.280     hshoexer  392:
                    393: if [ X"${ipsec}" != X"NO" ]; then
                    394:        if [ -f ${ipsec_rules} ]; then
                    395:                ipsecctl -f ${ipsec_rules}
                    396:        fi
1.40      provos    397: fi
1.1       deraadt   398:
1.379     deraadt   399: echo -n 'starting RPC daemons:'
1.399     dlg       400: start_daemon portmap ypldap
1.376     deraadt   401: if [ X"`domainname`" != X"" ]; then
1.385     deraadt   402:        start_daemon ypserv ypbind yppasswdd
1.376     deraadt   403: fi
1.399     dlg       404: start_daemon mountd nfsd lockd statd amd
1.1       deraadt   405: echo '.'
1.58      deraadt   406:
1.278     otto      407: mount -a
1.172     miod      408: swapctl -A -t noblk
1.1       deraadt   409:
                    410: # /var/crash should be a directory or a symbolic link
                    411: # to the crash directory if core dumps are to be saved.
                    412: if [ -d /var/crash ]; then
1.188     tholo     413:        savecore ${savecore_flags} /var/crash
1.90      art       414: fi
                    415:
1.266     millert   416: if [ X"${check_quotas}" = X"YES" ]; then
1.41      downsj    417:        echo -n 'checking quotas:'
                    418:        quotacheck -a
                    419:        echo ' done.'
                    420:        quotaon -a
                    421: fi
1.1       deraadt   422:
1.376     deraadt   423: kvm_mkdb                       # build kvm(3) databases
1.1       deraadt   424: dev_mkdb
1.101     deraadt   425: chmod 666 /dev/tty[pqrstuvwxyzPQRST]*
1.226     millert   426: chown root:wheel /dev/tty[pqrstuvwxyzPQRST]*
1.1       deraadt   427:
                    428: # check the password temp/lock file
1.17      deraadt   429: if [ -f /etc/ptmp ]; then
1.1       deraadt   430:        logger -s -p auth.err \
1.376     deraadt   431:            'password file may be incorrect -- /etc/ptmp exists'
1.32      deraadt   432: fi
                    433:
1.49      millert   434: echo clearing /tmp
                    435:
                    436: # prune quickly with one rm, then use find to clean up /tmp/[lq]*
                    437: # (not needed with mfs /tmp, but doesn't hurt there...)
1.339     sthen     438: (cd /tmp && rm -rf [a-km-pr-zA-Z]*)
                    439: (cd /tmp &&
1.49      millert   440:     find . ! -name . ! -name lost+found ! -name quota.user \
1.103     millert   441:        ! -name quota.group -execdir rm -rf -- {} \; -type d -prune)
1.373     deraadt   442:
                    443: setup_X_sockets
1.203     hugh      444:
1.72      deraadt   445: [ -f /etc/rc.securelevel ] && . /etc/rc.securelevel
1.266     millert   446: if [ X"${securelevel}" != X"" ]; then
1.33      millert   447:        echo -n 'setting kernel security level: '
1.234     jmc       448:        sysctl kern.securelevel=${securelevel}
1.1       deraadt   449: fi
                    450:
1.34      deraadt   451: # patch /etc/motd
                    452: if [ ! -f /etc/motd ]; then
                    453:        install -c -o root -g wheel -m 664 /dev/null /etc/motd
                    454: fi
1.364     guenther  455: if T=`mktemp /tmp/_motd.XXXXXXXXXX`; then
1.102     millert   456:        sysctl -n kern.version | sed 1q > $T
                    457:        echo "" >> $T
                    458:        sed '1,/^$/d' < /etc/motd >> $T
                    459:        cmp -s $T /etc/motd || cp $T /etc/motd
                    460:        rm -f $T
                    461: fi
1.34      deraadt   462:
1.298     ajacouto  463: if [ X"${accounting}" = X"YES" ]; then
                    464:        if [ ! -f /var/account/acct ]; then
                    465:                touch /var/account/acct
                    466:        fi
1.1       deraadt   467:        echo 'turning on accounting';   accton /var/account/acct
                    468: fi
                    469:
1.363     deraadt   470: if [ -f /sbin/ldconfig ]; then
1.115     deraadt   471:        echo 'creating runtime link editor directory cache.'
                    472:        if [ -d /usr/local/lib ]; then
1.183     todd      473:                shlib_dirs="/usr/local/lib $shlib_dirs"
1.115     deraadt   474:        fi
                    475:        if [ -d /usr/X11R6/lib ]; then
1.183     todd      476:                shlib_dirs="/usr/X11R6/lib $shlib_dirs"
1.115     deraadt   477:        fi
                    478:        ldconfig $shlib_dirs
1.231     millert   479: fi
                    480:
1.376     deraadt   481: echo 'preserving editor files.';       /usr/libexec/vi.recover
1.244     markus    482:
1.353     robert    483: echo -n 'starting network daemons:'
1.404     kettenis  484: start_daemon ldomd sshd snmpd ldpd ripd ospfd ospf6d bgpd ifstated
1.383     deraadt   485: start_daemon relayd dhcpd dhcrelay mrouted dvmrpd
1.127     itojun    486:
                    487: if ifconfig lo0 inet6 >/dev/null 2>&1; then
                    488:        fw=`sysctl -n net.inet6.ip6.forwarding`
1.266     millert   489:        if [ X"${fw}" = X"0" ]; then
1.353     robert    490:                start_daemon rtsold
1.127     itojun    491:        else
1.376     deraadt   492:                start_daemon route6d rtadvd
1.127     itojun    493:        fi
1.281     reyk      494: fi
                    495:
1.407     ajacouto  496: start_daemon hostapd rwhod lpd sendmail smtpd httpd slowcgi nginx ftpd
                    497: start_daemon ftpproxy tftpd tftpproxy identd inetd rarpd bootparamd
1.408     tedu      498: start_daemon rbootd mopd spamd spamlogd kdc kadmind kpasswdd
1.407     ajacouto  499: start_daemon ipropd_master ipropd_slave sndiod
1.377     robert    500: echo '.'
1.335     deraadt   501:
                    502: # If rc.firstime exists, run it just once, and make sure it is deleted
                    503: if [ -f /etc/rc.firsttime ]; then
                    504:        mv /etc/rc.firsttime /etc/rc.firsttime.run
1.384     halex     505:        . /etc/rc.firsttime.run 2>&1 | tee /dev/tty |
1.392     halex     506:                mail -Es "`hostname` rc.firsttime output" root >/dev/null
1.335     deraadt   507: fi
                    508: rm -f /etc/rc.firsttime.run
1.352     ajacouto  509:
                    510: # Run rc.d(8) scripts from packages
1.380     ajacouto  511: if [ -n "${pkg_scripts}" ]; then
1.352     ajacouto  512:        echo -n 'starting package daemons:'
1.380     ajacouto  513:        for _r in $pkg_scripts; do
1.368     robert    514:                [ -x /etc/rc.d/${_r} ] && start_daemon ${_r}
1.352     ajacouto  515:        done
                    516:        echo '.'
                    517: fi
1.17      deraadt   518:
1.72      deraadt   519: [ -f /etc/rc.local ] && . /etc/rc.local
1.73      millert   520:
1.379     deraadt   521: ifconfig -g carp -carpdemote 128       # disable carp interlock
1.286     mcbride   522:
1.379     deraadt   523: mixerctl_conf
                    524: echo -n 'starting local daemons:'
1.386     deraadt   525: start_daemon apmd sensorsd hotplugd watchdogd cron wsmoused xdm
1.73      millert   526: echo '.'
1.1       deraadt   527:
                    528: date
                    529: exit 0